#include <stdio.h>
#include <string.h>
#include "cui.h"
#include "esc.h"
#include "handler.h"
#include "label.h"
#include "button.h"
#include "dialog.h"

int
joke_hdr(cui obj, int evt, int val, void *prm)
{
	cui lb = (cui)prm, b2 = lb->children, b1 = b2->next;
	char *s = cui_button_str_get(obj);

	if(strcmp(s, "reboot") == 0 || strcmp(s, "power off") == 0){
		cui_label_str_set(lb, "It's a joke");
		cui_button_str_set(b1, "sorry");
		cui_x_set(b1, lb->w + 1);
		cui_hide(b2);
		cui_focus_set(b1);
		cui_w_set(lb, b1->x + b1->w);		
	}else{
		cui_hide(lb);	
		cui_focus_set(NULL);
		cui_draw(lb->parent);
		cui_quit();
	}
	return TRUE;
}

cui
joke_new(cui parent, int x, int y)
{
	cui lb = cui_label_new(parent, x, y, "system panic!");
	cui b1 = cui_button_new(lb, lb->w + 1, 0, "reboot");
	cui b2 = cui_button_new(lb, b1->x + b1->w + 1, 0, "power off");
	cui_w_set(lb, b2->x + b2->w);
	cui_bind(b1, CUI_EVT_BUTTON, joke_hdr, lb);
	cui_bind(b2, CUI_EVT_BUTTON, joke_hdr, lb);
	return lb;
}

int
my_hdr(cui obj, int evt, int val, void *prm)
{
	cui joke;
	cui_simple_dialog p = (cui_simple_dialog)prm;
	cui_label_str_set(p->label, "Realy ?");
	cui_button_str_set(p->btn1, "Yes");
	cui_button_str_set(p->btn2, "No");
	cui_unbind(obj, CUI_EVT_BUTTON, my_hdr);
	joke = joke_new(((cui)p)->parent, 0, 4);
	cui_main(joke, joke->children->next);
	cui_del(joke);
	cui_free(joke);
	return TRUE;
}

int
my_hdr2(cui obj, int evt, int val, void *prm)
{
	cui dlg = (cui)prm;
	if(cui_is_visible(dlg)) cui_hide(dlg);
	else cui_show(dlg);
	cui_button_str_set(obj, cui_is_visible(dlg) ? "Hide Dialog" : "Show Dialog");
	return TRUE;
}

int
main()
{
	cui base = cui_base_new(NULL, 0, 0, 40, 20);
	cui btn = cui_button_new(base, 2, 1, "Show Dialog");
	cui dlg = cui_simple_dialog_new(base, 2, 2, "Are you sure ?", "OK", "Cancel");
	cui_simple_dialog p = (cui_simple_dialog)dlg;

	dlg->flags |= CUI_FLG_HIDE;
	cui_bind(btn, CUI_EVT_BUTTON, my_hdr2, p);
	cui_bind(p->btn1, CUI_EVT_BUTTON, my_hdr, p);

	cui_main(base, NULL);
	printf("result %s\n", p->btn_result);
	cui_free(base);
	return 0;
}

/* EOF */
