#include "focus.h"
#include "key.h"
#include <stdio.h>

int
cui_focus_move_val(cui obj, int key)
{
	if(cui_focus_get()) return cui_glen(obj, cui_focus_get());

	switch(key){
	case CUI_KEY_UP:
		return cui_gy(obj);
	case CUI_KEY_DOWN:
		return cui_gy(obj) + obj->h;
	case CUI_KEY_LEFT:
		return cui_gx(obj);
	case CUI_KEY_RIGHT:
		return cui_gx(obj) + obj->w;
	}
	return 0;	
}

cui
cui_focus_move_judge_chain(cui obj, int key, cui old, int *val)
{
	if(obj == NULL) return old;
	old = cui_focus_move_judge_chain(obj->next, key, old, val);
	return cui_focus_move_judge(obj, key, old, val);
}

cui
cui_focus_move_judge(cui obj, int key, cui old, int *val)
{
	int v, jg = FALSE;
	cui focus = cui_focus_get();

	if(obj == NULL) return old;
	old = cui_focus_move_judge_chain(obj->children, key, old, val);

	if(obj == focus) return old;
	if(!(obj->flags & CUI_FLG_CAN_FOCUS)) return old;
	if(!cui_is_visible(obj)) return old;
	switch(key){
	case CUI_KEY_UP:
	case CUI_KEY_DOWN:
	case CUI_KEY_LEFT:
	case CUI_KEY_RIGHT:
		break;
	default:
		return old;
	}

	v = cui_focus_move_val(obj, key);
	if(focus){
		switch(key){
		case CUI_KEY_UP:
			jg = cui_gy(obj) <= cui_gy(focus);
			break;
		case CUI_KEY_DOWN:
			jg = cui_gy(obj) + obj->h >= cui_gy(focus) + focus->h;
			break;
		case CUI_KEY_LEFT:
			jg = cui_gx(obj) <= cui_gx(focus);
			break;
		case CUI_KEY_RIGHT:
			jg = cui_gx(obj) + obj->w >= cui_gx(focus) + focus->w;
			break;
		}
		if(old) jg = jg && v < *val;
	}else if(!old){
		jg = TRUE;
	}else{
		switch(key){
		case CUI_KEY_UP:
		case CUI_KEY_LEFT:
			jg = v < *val;
			break;
		case CUI_KEY_DOWN:
		case CUI_KEY_RIGHT:
			jg = v > *val;
			break;
		}
	}
	if(jg) *val = v;
	return jg ? obj : old;
}

/* EOF */
